# Trisquel SD card images
#
# Credit for the upstream code: https://sd-card-images.johang.se
#
# Modified by ThinkPenguin, Inc for use with Trisquel & the TPE-R1500 December 2024

This repository is a bunch of scripts to build a Trisquel 11 SD card image for the TPE-R1500. Emphasis is on pureness; pure Trisquel from the official Trisquel repositories, pure mainline U-boot built from source, and an otherwise pure but deblobbed ARM Trusted Firmware.

## Usage

The generated SD card images are made up of two separate images:

* **boot-BOARD.bin**: Boot image that contains partition table, U-Boot and chip-specific code. The boot image will only work on the board it's built for. 
* **trisquel-ARCH-VERSION-PASSWORD.bin**: Trisquel ext4 root filesystem image that contains a complete Trisquel installation, including official linux-libre Trisquel repo pulled kernel, initrd and device tree. This Trisquel image is generic and will work on all chips and boards with the CPU architecture it's built for. The filename indicates Trisquel version, CPU architecture and default root password.

These two images are the concatenated to a single image, which is then written to SD card, for example like this:

    $ zcat boot-r1500.bin.gz trisquel-aramo-arm64-XXXXXX.bin.gz > sd-card.img
    # dd if=sd-card.img of=/dev/sdXXX

### Build your own boot image

To build a boot image for the TPE-R1500:

    wget the script tar.gz file
    tar xf script.tar.gz
    mkdir -p /tmp/sd-images
    docker run --rm -v /tmp/sd-images:/artifacts sd-images build-boot r1500 rk3399 nanopi-r4s-rk3399_defconfig aarch64-linux-gnu

The image will end up in /tmp/sd-images on the host.

